 using Distributed

  # Calulate pi using Monte Carlo method  (throw darts at a unit square)
  #  Random X,Y in unit square (dart hit), if inside unit circle, count the hit
  #  Then pi = (hits/N)*4
  # If debugging, uncomment the "using Printf" and place "@printf" macro in code
  # using Printf

  # Add  @everywere to make all 8 cores/processes avaiable of the function
  # Note: processes can be on other nodes

  @everywhere function dart_pi(N::Int)
      # Compute pi with a Monte Carlo simulation of N darts thrown in unit square
      hit_circle = 0  # counts number of points that have radial coordinate < 1, i.e. in circle
      for i = 1:N
          x = rand()   # uniformly distributed number on x-axis
          y = rand()   # uniformly distributed number on y-axis
          # @printf("X=%f  Y=%f\n",x,y)
          r2 = x*x + y*y  # calculate radius
          if r2 < 1.0
              hit_circle += 1
          end
      end
      return (hit_circle / N) * 4.0
  end
  # find out how many cores were are using
  cores=nprocs()
  # now on each cores run dart_pi and collect resutls (reduction)
  sum_of_cores = @distributed (+) for i=1:cores
      dart_pi(100000000)
   end
  # compute the average
  return sum_of_cores/cores  

